/*-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class              	G3DFunctions
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DFunctions.h,v 1.22 2001/01/05 20:50:48 robert Exp $
//
//---------------------------------------------------------------------------*/

#ifndef __G3DFunctions_h_INCLUDE
#define __G3DFunctions_h_INCLUDE

#ifndef __G3DIE__
#define __G3DIE__ __inline__ extern
#endif

#ifndef __G3DI__
#define __G3DI__ __inline__
#endif

#ifndef __G3DE__
#define __G3DE__ extern
#endif

#ifndef CFLOAT
#define CFLOAT const float
#endif CFLOAT

#ifndef CDOUBLE
#define CDOUBLE const double
#endif CDOUBLE

/******************************************************************************
 *
 * Some usefuls vectors and matrices
 *
 *****************************************************************************/

__G3DE__ float  G3DOrigin3f[3];
__G3DE__ double G3DOrigin3d[3];
__G3DE__ float  G3DOrigin4f[4];
__G3DE__ double G3DOrigin4d[4];

__G3DE__ float  G3DUnityVecX2f[2];
__G3DE__ float  G3DUnityVecY2f[2];
__G3DE__ double G3DUnityVecX2d[2];
__G3DE__ double G3DUnityVecY2d[2];

__G3DE__ float  G3DUnityVecX3f[3];
__G3DE__ float  G3DUnityVecY3f[3];
__G3DE__ float  G3DUnityVecZ3f[3];
__G3DE__ double G3DUnityVecX3d[3];
__G3DE__ double G3DUnityVecY3d[3];
__G3DE__ double G3DUnityVecZ3d[3];

__G3DE__ float  G3DUnityVecX4f[4];
__G3DE__ float  G3DUnityVecY4f[4];
__G3DE__ float  G3DUnityVecZ4f[4];
__G3DE__ float  G3DUnityVecW4f[4];
__G3DE__ double G3DUnityVecX4d[4];
__G3DE__ double G3DUnityVecY4d[4];
__G3DE__ double G3DUnityVecZ4d[4];
__G3DE__ double G3DUnityVecW4d[4];

__G3DE__ float  G3DIdentityMatrix3f[9];
__G3DE__ double G3DIdentityMatrix3d[9];

__G3DE__ float  G3DIdentityMatrix4f[16];
__G3DE__ double G3DIdentityMatrix4d[16];

__G3DE__ float  G3DDefaultPlane4f[4];
__G3DE__ double G3DDefaultPlane4d[4];

/******************************************************************************
 *
 * Misc Functions 
 *
 *****************************************************************************/

/*
 * res = lambda * a + (1 - lambda) * b
 */

__G3DIE__ void G3DLinearInterpolateVector3fv(float res[3], CFLOAT a[3], CFLOAT b[3], CFLOAT lambda);
__G3DIE__ void G3DLinearInterpolateVector3dv(double res[3], CDOUBLE a[3], CDOUBLE b[3], CDOUBLE lambda);

/*
 *
 */

__G3DIE__ float G3DDistanceFromPlanef(CFLOAT point[3],CFLOAT plane[4]);
__G3DIE__ double G3DDistanceFromPlaned(CDOUBLE point[3],CDOUBLE plane[4]);

/*
 *
 */

__G3DIE__ int G3DCompareFloat(float a, float b, float tol);
__G3DIE__ int G3DCompareDouble(double a, double b, double tol);

/*
 *
 */

__G3DIE__ void G3DFloatsFromDoubles(float* dest, CDOUBLE *src, const int size);
__G3DIE__ void G3DDoublesFromFloats(double* dest, CFLOAT *src, const int size);

#endif









