/* 
 * G3DMatrixFunc.h created by robert on 2001-01-05 15:07:28 +0000
 *
 * Project GeometryKit
 *
 * Created with ProjectCenter - http://www.projectcenter.ch
 *
 * $Id: G3DMatrixFunc.h,v 1.3 2001/01/05 19:17:58 robert Exp $
 */

#ifndef __G3DMatrixFunc_h_INCLUDE
#define __G3DMatrixFunc_h_INCLUDE

#include <GeometryKit/G3DFunctions.h>

/*
 *
 */

__G3DIE__ void G3DVector3fXMatrix3f(float res[3],  CFLOAT vec[3], CFLOAT matrix[9]);
__G3DIE__ void G3DVector3dXMatrix3d(double res[3],  CDOUBLE vec[3], CDOUBLE matrix[9]);

__G3DIE__ void G3DMatrix3fXVector3f(float res[3],  CFLOAT matrix[9], CFLOAT vector[3]);
__G3DIE__ void G3DMatrix3dXVector3d(double res[3],  CDOUBLE matrix[9], CDOUBLE vector[3]);

__G3DIE__ void G3DVector4fXMatrix4f(float res[4],  CFLOAT vec[4], CFLOAT matrix[16]);
__G3DIE__ void G3DVector4dXMatrix4d(double res[4],  CDOUBLE vec[4], CDOUBLE matrix[16]);

__G3DIE__ void G3DMatrix4fXVector4f(float res[4],  CFLOAT matrix[16], CFLOAT vec[4]);
__G3DIE__ void G3DMatrix4dXVector4d(double res[4],  CDOUBLE matrix[16], CDOUBLE vec[4]);

__G3DIE__ void G3DMatrix4fXVector3f(float res[3],  CFLOAT matrix[16], CFLOAT vec[3]);
__G3DIE__ void G3DMatrix4dXVector3d(double res[3],  CDOUBLE matrix[16], CDOUBLE vec[3]);

/*
 *
 */

__G3DIE__ void G3DCopyMatrix3fv(float m1[9], CFLOAT m2[9]);
__G3DIE__ void G3DCopyMatrix3dv(double m1[9], CDOUBLE m2[9]);

__G3DIE__ void G3DCopyMatrix4fv(float m1[16], CFLOAT m2[16]);
__G3DIE__ void G3DCopyMatrix4dv(double m1[16], CDOUBLE m2[16]);

/*
 *
 */

__G3DIE__ float G3DDeterminante2f(CFLOAT a, CFLOAT b, CFLOAT c, CFLOAT d);
__G3DIE__ double G3DDeterminante2d(CDOUBLE a, CDOUBLE b, CDOUBLE c, CDOUBLE d);

__G3DIE__ float G3DDeterminante3fv(CFLOAT a[3],CFLOAT b[3],CFLOAT c[3]);
__G3DIE__ double G3DDeterminante3dv(CDOUBLE a[3],CDOUBLE b[3],CDOUBLE c[3]);
__G3DIE__ float G3DDeterminante3f(CFLOAT a1,CFLOAT a2,CFLOAT a3,CFLOAT b1,CFLOAT b2,CFLOAT b3,CFLOAT c1,CFLOAT c2,CFLOAT c3);
__G3DIE__ double G3DDeterminante3d(CDOUBLE a1,CDOUBLE a2,CDOUBLE a3,CDOUBLE b1,CDOUBLE b2,CDOUBLE b3,CDOUBLE c1,CDOUBLE c2,CDOUBLE c3);

__G3DIE__ float G3DDeterminante4fv(CFLOAT m[16]);
__G3DIE__ double G3DDeterminante4dv(CDOUBLE m[16]);

/*
 *
 */

__G3DIE__ void G3DMakeIdentity3fv(float m[9]);
__G3DIE__ void G3DMakeIdentity3dv(double m[9]);
__G3DIE__ void G3DMakeIdentity4fv(float m[16]);
__G3DIE__ void G3DMakeIdentity4dv(double m[16]);

/*
 *
 */

__G3DIE__ void G3DAddMatrix3fv(float m[9],CFLOAT a[9],CFLOAT b[9]);
__G3DIE__ void G3DAddMatrix3dv(double m[9],CDOUBLE a[9],CDOUBLE b[9]);
__G3DIE__ void G3DAddMatrix4fv(float m[16],CFLOAT a[16],CFLOAT b[16]);
__G3DIE__ void G3DAddMatrix4dv(double m[16],CDOUBLE a[16],CDOUBLE b[16]);

/*
 *
 */

__G3DIE__ void G3DSubMatrix3fv(float m[9],CFLOAT a[9],CFLOAT b[9]);
__G3DIE__ void G3DSubMatrix3dv(double m[9],CDOUBLE a[9],CDOUBLE b[9]);
__G3DIE__ void G3DSubMatrix4fv(float m[16],CFLOAT a[16],CFLOAT b[16]);
__G3DIE__ void G3DSubMatrix4dv(double m[16],CDOUBLE a[16],CDOUBLE b[16]);

/*
 *
 */

__G3DIE__ void G3DMultiplyMatrix3fv(float m[9], CFLOAT a[9], CFLOAT b[9]);
__G3DIE__ void G3DMultiplyMatrix3dv(double m[9], CDOUBLE a[9], CDOUBLE b[9]);
__G3DIE__ void G3DMultiplyMatrix4fv(float m[16], CFLOAT a[16], CFLOAT b[16]);
__G3DIE__ void G3DMultiplyMatrix4dv(double m[16], CDOUBLE a[16],CDOUBLE b[16]);

/*
 *
 */

__G3DIE__ void G3DSimpleInvertMatrix4fv(float i[16], CFLOAT matrix[16]);
__G3DIE__ void G3DSimpleInvertMatrix4dv(double i[16], CDOUBLE matrix[16]);
/* Only works for rotation/translation, that is orthogonal matrices! */

/*
 *
 */

__G3DIE__ int G3DInvertMatrix4fv(float i[16], CFLOAT matrix[16]);
__G3DIE__ int G3DInvertMatrix4dv(double i[16], CDOUBLE matrix[16]);
/* General invertation function */

/*
 *
 */

extern void G3DAdjointMatrix4fv(float adj[16], CFLOAT m[16]);
extern void G3DAdjointMatrix4dv(double adj[16], CDOUBLE m[16]);

/*
 *
 */

__G3DIE__ void G3DTransposeMatrix3fv(float t[9], CFLOAT matrix[9]);
__G3DIE__ void G3DTransposeMatrix3dv(double t[9], CDOUBLE matrix[9]);
__G3DIE__ void G3DTransposeMatrix4fv(float t[16], CFLOAT matrix[16]);
__G3DIE__ void G3DTransposeMatrix4dv(double t[16], CDOUBLE matrix[16]);

/*
 *
 */

__G3DIE__ void G3DMakeXRotation3f(float matrix[9],CFLOAT angle);
__G3DIE__ void G3DMakeXRotation3d(double matrix[9],CDOUBLE angle);
__G3DIE__ void G3DMakeYRotation3f(float matrix[9],CFLOAT angle);
__G3DIE__ void G3DMakeYRotation3d(double matrix[9],CDOUBLE angle);
__G3DIE__ void G3DMakeZRotation3f(float matrix[9],CFLOAT angle);
__G3DIE__ void G3DMakeZRotation3d(double matrix[9],CDOUBLE angle);

__G3DIE__ void G3DMakeXRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeXRotation4d(double matrix[16],CDOUBLE angle);
__G3DIE__ void G3DMakeYRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeYRotation4d(double matrix[16],CDOUBLE angle);
__G3DIE__ void G3DMakeZRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeZRotation4d(double matrix[16],CDOUBLE angle);

/*
 *
 */

__G3DIE__ void G3DMakeInvXRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeInvXRotation4d(double matrix[16],CDOUBLE angle);
__G3DIE__ void G3DMakeInvYRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeInvYRotation4d(double matrix[16],CDOUBLE angle);
__G3DIE__ void G3DMakeInvZRotation4f(float matrix[16],CFLOAT angle);
__G3DIE__ void G3DMakeInvZRotation4d(double matrix[16],CDOUBLE angle);

/*
 *
 */

__G3DIE__ void G3DMakeRotation3f(float matrix[9],CFLOAT angle,CFLOAT axis[3]);
__G3DIE__ void G3DMakeRotation3d(double matrix[9],CDOUBLE angle,CDOUBLE axis[3]);
__G3DIE__ void G3DMakeRotation4f(float matrix[16],CFLOAT angle,CFLOAT axis[3]);
__G3DIE__ void G3DMakeRotation4d(double matrix[16],CDOUBLE angle,CDOUBLE axis[3]);

/*
 *
 */

__G3DIE__ void G3DMakeTranslation4f(float matrix[16],CFLOAT v[3]);
__G3DIE__ void G3DMakeTranslation4d(double matrix[16],CDOUBLE v[3]);

/*
 *
 */

__G3DIE__ void G3DMakeTranslationRotation4f(float res[16],CFLOAT t[3],CFLOAT rot[3]);
__G3DIE__ void G3DMakeTranslationRotation4d(double res[16],CDOUBLE t[3],CDOUBLE rot[3]);

/*
 *
 */

__G3DIE__ void G3DMakeTranslationRotationScale4f(float res[16],CFLOAT t[3],CFLOAT rot[16], CFLOAT scale);
__G3DIE__ void G3DMakeTranslationRotationScale4d(double res[16],CDOUBLE t[3],CDOUBLE rot[16], CDOUBLE scale);

/*
 *
 */

__G3DIE__ void G3DMakeTranslationQuatScale4f(float res[16],CFLOAT t[3],CFLOAT quat[4], CFLOAT scale);
__G3DIE__ void G3DMakeTranslationQuatScale4d(double res[16],CDOUBLE t[3],CDOUBLE quat[4], CDOUBLE scale);

/*
 *
 */

__G3DIE__ void G3DMakeScale3fv(float m[9],CFLOAT scale[3]);
__G3DIE__ void G3DMakeScale3dv(double m[9],CDOUBLE scale[3]);

__G3DIE__ void G3DMakeScale4fv(float m[16],CFLOAT scale[3]);
__G3DIE__ void G3DMakeScale4dv(double m[16],CDOUBLE scale[3]);

/*
 *
 */

__G3DIE__ void G3DMakeEulerTransform4fv(float euler[16], CFLOAT hpr[3]);
__G3DIE__ void G3DMakeEulerTransform4dv(double euler[16], CDOUBLE hpr[3]);

/*
 *
 */

__G3DIE__ void G3DHPRFromEulerTransform4fv(float hpr[3], CFLOAT euler[16]);
__G3DIE__ void G3DHPRFromEulerTransform4dv(double hpr[3],CDOUBLE euler[16]);

/*
 *
 */

__G3DIE__ void G3DInvertEulerTransform4fv(float inv[16], CFLOAT euler[16]);
__G3DIE__ void G3DInvertEulerTransform4dv(double inv[16],CDOUBLE euler[16]);

#endif
