/* 
 * G3DQuatFunc.h created by robert on 2001-01-05 15:07:37 +0000
 *
 * Project GeometryKit
 *
 * Created with ProjectCenter - http://www.projectcenter.ch
 *
 * $Id: G3DQuatFunc.h,v 1.3 2001/01/05 19:17:58 robert Exp $
 */

#ifndef __G3DQuatFunc_h_INCLUDE
#define __G3DQuatFunc_h_INCLUDE

#include <GeometryKit/G3DFunctions.h>

/* 
 * [ ww' - v.v', vxv' + wv' + v'w ] 
 */

__G3DIE__ void G3DMultiplyQuatf(float dst[4],CFLOAT a[4],CFLOAT b[4]);
__G3DIE__ void G3DMultiplyQuatd(double dst[4],CDOUBLE a[4],CDOUBLE b[4]);

/*
 *
 */

__G3DIE__ void G3DQuatFromAngleAxisf(float quat[4], CFLOAT angle, CFLOAT axis[3]);
__G3DIE__ void G3DQuatFromAngleAxisd(double quat[4], CDOUBLE angle, CDOUBLE axis[3]);

/*
 *
 */

__G3DIE__ void G3DQuatFromRotationVectorf(float quat[4], CFLOAT axis[3]);
__G3DIE__ void G3DQuatFromRotationVectord(double quat[4], CDOUBLE axis[3]);

/*
 *
 */

__G3DIE__ void G3DAngleAxisFromQuatf(float *angle, float axis[3], CFLOAT quat[4]);
__G3DIE__ void G3DAngleAxisFromQuatd(double *angle, double axis[3], CDOUBLE quat[4]);

/*
 *
 */

__G3DIE__ void G3DMatrixFromQuatf(float m[16], CFLOAT q[4]);
__G3DIE__ void G3DMatrixFromQuatd(double m[16], CDOUBLE q[4]);

__G3DIE__ void G3DQuatFromMatrixf(float q[4], CFLOAT m[16]);
__G3DIE__ void G3DQuatFromMatrixd(double q[4], CDOUBLE m[16]);

/*
 *
 */

__G3DIE__ void G3DEulerRepFromQuatf(float res[3], CFLOAT quat[4]);
__G3DIE__ void G3DEulerRepFromQuatd(double res[3], CDOUBLE quat[4]);

__G3DIE__ void G3DQuatFromEulerRepf(float q[4],CFLOAT euler[3]);
__G3DIE__ void G3DQuatFromEulerRepd(double q[4],CDOUBLE euler[3]);

/*
 *
 */

__G3DIE__ void G3DInterpolateQuatf(float res[4], CFLOAT from[4], CFLOAT to[4], CFLOAT t);
__G3DIE__ void G3DInterpolateQuatd(double res[4], CDOUBLE from[4], CDOUBLE to[4], CDOUBLE t);

#endif
