//-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class		G3DVector2f
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector2f.h,v 1.4 2001/01/05 20:50:49 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector2f_h_INCLUDE
#define __G3DVector2f_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple2f.h>

@interface G3DVector2f : G3DTuple2f
{
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DVector2f *)vector2f;
+ (G3DVector2f *)vector2fWithValues:(float *)vals;
+ (G3DVector2f *)vector2fWithX:(float)x y:(float)y;
+ (G3DVector2f *)vector2fWithVector2f:(G3DVector2f *)vec;

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector2f *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector2f *)vectorByAdding:(G3DVector2f *)aVector;
- (G3DVector2f *)vectorBySubtracting:(G3DVector2f *)aVector;

- (G3DVector2f *)vectorByMultiplyingBy:(float)aScalar;
- (G3DVector2f *)vectorByDividingBy:(float)aScalar;

- (float)dotProduct:(G3DVector2f *)aVec;

- (float)length;

- (float)squaredLength;

- (void)normalise;

- (G3DVector2f *)normalisedVector;

@end

#endif







