//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DVector3d
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector3d.h,v 1.5 2001/01/05 20:50:49 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector3d_h_INCLUDE
#define __G3DVector3d_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple3d.h>

@interface G3DVector3d : G3DTuple3d
{
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DVector3d *)vector3d;
+ (G3DVector3d *)vector3dWithValues:(double *)vals;
+ (G3DVector3d *)vector3dWithX:(double)x y:(double)y z:(double)z;
+ (G3DVector3d *)vector3dWithVector3d:(G3DVector3d *)vec;

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector3d *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector3d *)vectorByAdding:(G3DVector3d *)aVector;
- (G3DVector3d *)vectorBySubtracting:(G3DVector3d *)aVector;

- (G3DVector3d *)vectorByMultiplyingBy:(double)aScalar;
- (G3DVector3d *)vectorByDividingBy:(double)aScalar;

- (double)dotProduct:(G3DVector3d *)aVec;

- (void)crossProductWith:(G3DVector3d *)aVec and:(G3DVector3d *)bVec;

- (double)length;

- (double)squaredLength;

- (void)normalise;

- (G3DVector3d *)normalisedVector;

@end

#endif







