//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DVector3f
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector3f.h,v 1.4 2001/01/05 20:50:49 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector3f_h_INCLUDE
#define __G3DVector3f_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple3f.h>

@interface G3DVector3f : G3DTuple3f
{
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DVector3f *)vector3f;
+ (G3DVector3f *)vector3fWithValues:(float *)vals;
+ (G3DVector3f *)vector3fWithX:(float)x y:(float)y z:(float)z;
+ (G3DVector3f *)vector3fWithVector3f:(G3DVector3f *)vec;

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector3f *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector3f *)vectorByAdding:(G3DVector3f *)aVector;
- (G3DVector3f *)vectorBySubtracting:(G3DVector3f *)aVector;

- (G3DVector3f *)vectorByMultiplyingBy:(float)aScalar;
- (G3DVector3f *)vectorByDividingBy:(float)aScalar;

- (float)dotProduct:(G3DVector3f *)aVec;

- (void)crossProductWith:(G3DVector3f *)aVec and:(G3DVector3f *)bVec;

- (float)length;

- (float)squaredLength;

- (void)normalise;

- (G3DVector3f *)normalisedVector;

@end

#endif







