//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DArchivingInfo
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Apr 13 14:14:18 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DArchivingInfo.h,v 1.5 2001/07/07 15:35:47 probert Exp $
//-----------------------------------------------------------------------------

/*
  Description:
  
*/

#ifndef __G3DArchivingInfo_h_INCLUDE
#define __G3DArchivingInfo_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DSceneCoding.h>

@class G3DArchiver;
@class G3DUnarchiver;

@interface G3DArchivingInfo : NSObject
{
  NSString* className;
  int version;
  BOOL isWritten;
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (id)archivingInfoWithClassName: (NSString*)name version:(int)version;

//-----------------------------------------------------------------------------
// Accessor methods
//-----------------------------------------------------------------------------

- (NSString *)className;
- (int)version;

- (void)setIsWritten:(BOOL)flag;
- (BOOL)isWritten;

@end

@interface NSString (SceneArchiving)

- (void)encodeWithSceneArchiver:(id)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;
- (Class)classForSceneArchiver;

@end

@interface NSMutableString (SceneArchiving)

- (Class)classForSceneArchiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver*)unarchiver;

@end

@interface NSArray (SceneArchiving)

- (void)encodeWithSceneArchiver:(id)archiver;
- (Class)classForSceneArchiver;

@end

@interface NSMutableArray (SceneArchiving)

- (id)initWithSceneUnarchiver:(G3DUnarchiver*)unarchiver;

@end

@interface NSDictionary (SceneArchiving)

- (void)encodeWithSceneArchiver:(id)archiver;
- (Class)classForSceneArchiver;

@end


@interface NSMutableDictionary (SceneArchiving)

- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface NSData (SceneArchiving)

- (void)encodeWithSceneArchiver:(id)archiver;
- (Class)classForSceneArchiver;

@end

#endif





