//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DAttributeNode
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Fri Mar 31 14:20:26 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DAttributeNode.h,v 1.7 2001/01/05 20:50:50 robert Exp $
//-----------------------------------------------------------------------------

/*
  Description:
  
*/

#ifndef __G3DAttributeNode_h_INCLUDE
#define __G3DAttributeNode_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DRenderEngine.h>
#import <RenderKit/G3DSceneCoding.h>

@interface G3DAttributeNode : NSObject <NSCopying, NSCoding, G3DSceneCoding>
{
  NSString *name;
}

//-----------------------------------------------------------------------------
// Attribute information
//-----------------------------------------------------------------------------

- (void)setName:(NSString *)aName;
- (NSString *)name;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




