//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DColour
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DColour.h,v 1.7 2001/01/05 20:50:51 robert Exp $
//-----------------------------------------------------------------------------

/*
 * Description:
 *
 * The colours are clamped to [0,1] automatically.
 *
 */

#ifndef __G3DColour_h_INCLUDE
#define __G3DColour_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DAttributeNode.h>

@interface G3DColour : G3DAttributeNode <NSCopying,NSCoding,G3DSceneCoding>
{
  float tuple[4];
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DColour *)colour;
+ (G3DColour *)colourWithColour:(G3DColour *)col;
+ (G3DColour *)colourWithR:(float)r g:(float)g b:(float)b a:(float)a;

//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

- (id)initWithR:(float)r g:(float)g b:(float)b a:(float)a;

//-----------------------------------------------------------------------------
// Accessor methods
//-----------------------------------------------------------------------------

- (float *)values;
- (void)setValues:(float *)values;

- (void)setRed:(float)r;
- (float)red;

- (void)setGreen:(float)g;
- (float)green;

- (void)setBlue:(float)b;
- (float)blue;

- (void)setAlpha:(float)a;
- (float)alpha;

- (BOOL)isEqualToColour:(G3DColour *)oCol;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




