//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DFunctions
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DFunctions.h,v 1.13 2001/07/15 12:39:24 probert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DRKFunctions_h_INCLUDE
#define __G3DRKFunctions_h_INCLUDE

#import <Foundation/Foundation.h>

#import <RenderKit/G3DTypes.h>
#import <RenderKit/G3DFrustum.h>
#import <RenderKit/G3DDefines.h>

extern float G3DSwapZAxisMatrix[16];

__G3DEI__ NSString *G3DStringFromFrustum(G3DFrustumValues fr);
__G3DEI__ NSString *G3DStringFromCoordinate(G3DCoordinate co);
__G3DEI__ NSString *G3DStringFromRange(G3DRange ra);
__G3DEI__ NSString *G3DStringFromBoundingSphere(G3DBoundingSphere bs);
__G3DEI__ NSString *G3DStringFromBoundingBox(G3DBoundingBox bb);

__G3DEI__ NSString *G3DStringFromMatrix4f(float *mat);
__G3DEI__ NSString *G3DStringFromMatrix4d(double *mat);

__G3DEI__ NSString *G3DStringFromVectord(double *vec, int size);
__G3DEI__ NSString *G3DStringFromVectorf(float *vec, int size);

/*
__G3DEI__ NSString *NSStringFromCameraFlags(G3D_CameraFlags cf);
*/

#endif




