//-----------------------------------------------------------------------------
// Project            	RenderKit
// Protocol		G3DGeometryBackend
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Sat Jul  8 16:15:07 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DGeometryBackend.h,v 1.5 2001/01/05 20:50:51 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DGeometryBackend_h_INCLUDE
#define __G3DGeometryBackend_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DRenderEngine.h>

@class G3DShape;

typedef enum {
  G3D_POINTS = GL_POINTS,
  G3D_LINES = GL_LINES,
  G3D_LINE_STRIP = GL_LINE_STRIP,
  G3D_LINE_LOOP = GL_LINE_LOOP,
  G3D_TRIANGLES = GL_TRIANGLES,
  G3D_TRIANGLE_STRIP = GL_TRIANGLE_STRIP,
  G3D_TRIANGLE_FAN = GL_TRIANGLE_FAN,
  G3D_QUADS = GL_QUADS,
  G3D_QUAD_STRIP = GL_QUAD_STRIP,
  G3D_POLYGON = GL_POLYGON
} G3DGeometryMode;

@protocol G3DGeometryBackend

- (void)drawGeometry;
- (void)precompile;
- (int)vertexCount;
- (void)getMin:(float *)min max:(float *)max;
- (void)setShape:(G3DShape *)aShape;

@end

#endif




