//-----------------------------------------------------------------------------
// Project            	RenderKit
// Categories		G3DGeometryExtensions
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DGeometryExtensions.h,v 1.7 2001/01/05 20:50:51 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DGeometryExtensions_h_INCLUDE
#define __G3DGeometryExtensions_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/GeometryKit.h>

#import <RenderKit/G3DSceneCoding.h>

@interface G3DTuple2d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DTuple2f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DTuple3d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DTuple3f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DTuple4d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DTuple4f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector2d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector2f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector3d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector3f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector4d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector4f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DQuaternion (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DVector (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DMatrix3d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DMatrix3f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DMatrix4d (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DMatrix4f (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DMatrix (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DBezier (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DBox (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DLine (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DPlane (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

@interface G3DSphere (GeometryArchiving) <G3DSceneCoding>

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




