//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DLeaf
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Wed Nov 24 10:13:29 CET 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DLeaf.h,v 1.8 2001/01/05 20:50:52 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DLeaf_h_INCLUDE
#define __G3DLeaf_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DGraphNode.h>

@interface G3DLeaf : G3DGraphNode <NSCopying, NSCoding, G3DSceneCoding>
{
  BOOL _useDisplayList;
  int dlist;
}

//-----------------------------------------------------------------------------
// Positioning
//-----------------------------------------------------------------------------

- (void)setPositionWithValues:(float *)pos;
- (void)setPositionWithTuple:(G3DTuple3f *)pos;
- (void)getPosition:(G3DTuple3f **)pos;
  // Uses the local transformation to set its position - so it is only local!

//-----------------------------------------------------------------------------
// Optimisation
//-----------------------------------------------------------------------------

- (void)setUseDisplayList:(BOOL)flag;
- (BOOL)useDisplayList;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;
  // Copying is deep!

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




