//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DNodeEnumerator
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Wed Nov 24 10:13:29 CET 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DNodeEnumerator.h,v 1.4 2001/01/05 20:50:53 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DNodeEnumerator_h_INCLUDE
#define __G3DNodeEnumerator_h_INCLUDE

#import <Foundation/Foundation.h>

@class G3DNodeList;

@interface G3DNodeEnumerator : NSEnumerator
{
  @private
  int position;
  int endPosition;  
  G3DNodeList *list;
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DNodeEnumerator *)nodeEnumeratorWithList:(G3DNodeList *)list startIndex:(unsigned int)startIndex stopIndex:(unsigned int)stop;

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithList:(G3DNodeList *)list startIndex:(unsigned int)startIndex stopIndex:(unsigned int)stop;

- (void)dealloc;

//-----------------------------------------------------------------------------
// Accessors
//-----------------------------------------------------------------------------

- (NSArray *)allObjects;
// Returns the collection being enumerated as an NSArray.

- (id)nextObject;
// Returns the next object from the collection being enumerated. When nextObject returns nil, all objects have been enumerated.

- (BOOL)containsMoreObjects;

@end

#endif






