//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DPositionTrigger
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DPositionTrigger.h,v 1.6 2001/01/05 20:50:53 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DPositionTrigger_h_INCLUDE
#define __G3DPositionTrigger_h_INCLUDE

#import <Foundation/Foundation.h>

#import <RenderKit/G3DTrigger.h>
#import <RenderKit/G3DAttributeNode.h>

@interface G3DPositionTrigger : G3DAttributeNode <G3DTrigger,NSCoding,NSCopying,G3DSceneCoding>
{
}

//-----------------------------------------------------------------------------
// Trigger
//-----------------------------------------------------------------------------

- (BOOL)triggerShouldActivate;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




