//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DRotator
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Fri Apr 28 08:37:15 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DRotator.h,v 1.7 2001/07/15 13:06:51 probert Exp $
//-----------------------------------------------------------------------------

/*
  Description:
  
*/

#ifndef __G3DRotator_h_INCLUDE
#define __G3DRotator_h_INCLUDE

#import <Foundation/Foundation.h>

@class G3DTransform;
@class G3DCamera;

typedef enum {
  G3D_AllAxes,
  G3D_XAxis,
  G3D_YAxis,
  G3D_ZAxis,
  G3D_XYAxis,
  G3D_XZAxis,
  G3D_YZAxis
} G3D_Axis;

@interface G3DRotator : NSObject
{
  G3DCamera *camera;
  G3D_Axis axis;

  @private
  NSPoint _center;
  float _radius;
}

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithCamera:(G3DCamera *)aCamera;

//-----------------------------------------------------------------------------
// Accessor methods
//-----------------------------------------------------------------------------

- (void)setCenter:(NSPoint)center radius:(float)radius;

- (void)setRotationAxis:(G3D_Axis)axis;
- (G3D_Axis)rotationAxis;

//-----------------------------------------------------------------------------
// Rotating
//-----------------------------------------------------------------------------

- (void)trackMouseFrom:(const NSPoint *)from to:(const NSPoint *)to rotation:(G3DTransform **)rotation;

@end

#endif




