//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DSwitchGroup
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DSwitchGroup.h,v 1.10 2001/01/05 20:50:55 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DSwitchGroup_h_INCLUDE
#define __G3DSwitchGroup_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DGroup.h>

@interface G3DSwitchGroup : G3DGroup <NSCoding, NSCopying, G3DSceneCoding>
{
  int index;
  int mask;
}

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithCapacity:(unsigned int)cap;

//-----------------------------------------------------------------------------
// Rendering and traversing the scenegraph
//-----------------------------------------------------------------------------

- (BOOL)canBeFlattened;
  // Returns NO!

//-----------------------------------------------------------------------------
// Switching methods
//-----------------------------------------------------------------------------

- (G3DGraphNode *)currentChild;

- (G3DGraphNode *)nextChild;
- (void)setNextChild:(G3DGraphNode *)aChild;

- (void)setSelectionMask:(int)aMask;
- (int)selectionMask;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




