//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DTimedSwitchGroup
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DTimedSwitchGroup.h,v 1.7 2001/01/05 20:50:55 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DTimedSwitchGroup_h_INCLUDE
#define __G3DTimedSwitchGroup_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DSwitchGroup.h>

@interface G3DTimedSwitchGroup : G3DSwitchGroup <NSCoding,NSCopying,G3DSceneCoding>
{
  NSTimeInterval interval;
  NSTimer *timer;
}

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithCapacity:(unsigned int)cap timeInterval:(NSTimeInterval)ti;

//-----------------------------------------------------------------------------
// Accessor methods
//-----------------------------------------------------------------------------

- (void)setInterval:(NSTimeInterval)ti;
- (NSTimeInterval)interval;

//-----------------------------------------------------------------------------
// NSCoding
//-----------------------------------------------------------------------------

- (void)encodeWithCoder:(NSCoder *)aCoder;
- (id)initWithCoder:(NSCoder *)aCoder;

//-----------------------------------------------------------------------------
// NSCopying
//-----------------------------------------------------------------------------

- (id)copyWithZone:(NSZone *)zone;

//-----------------------------------------------------------------------------
// G3DSceneCoding
//-----------------------------------------------------------------------------

- (void)encodeWithSceneArchiver:(G3DArchiver *)archiver;
- (id)initWithSceneUnarchiver:(G3DUnarchiver *)unarchiver;

@end

#endif




